#!/usr/bin/env python

# Define where is the file to open
import sys
sys.argv=["","GPL_List.txt"]

# Import used libraries
import urllib2
import re

# Define function to clean html tags
def clean_html(html):
    """
    Remove HTML markup from the given string.
    :param html: the HTML string to be cleaned
    :type html: str
    :rtype: str
    """
    # First we remove inline JavaScript/CSS:
    cleaned = re.sub(r"(?is)<(script|style).*?>.*?(</\1>)", "", html.strip())
    # Then we remove html comments. This has to be done before removing regular
    # tags since comments can contain '>' characters.
    cleaned = re.sub(r"(?s)<!--(.*?)-->[\n]?", "", cleaned)
    # Next we can remove the remaining tags:
    cleaned = re.sub(r"(?s)<.*?>", "", cleaned)
    # Finally, we deal with whitespace
    cleaned = re.sub(r"&nbsp;", " ", cleaned)
    cleaned = re.sub(r"  ", " ", cleaned)
    cleaned = re.sub(r"  ", " ", cleaned)
    # Remove first lines
    p=re.compile("(GEO Accession viewer\s*)", re.DOTALL)
    cleaned = p.sub("",cleaned)
    return cleaned.strip()

# Define function to dowload GPL files from GEO
def download(geo_file):
        address = "http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?view=data&acc=" + GPL
        page = urllib2.urlopen(address).read()
        name_file = GPL + ".txt"
        raw = clean_html(page)
        gpl_file = open(name_file, "w")
        gpl_file.write(raw)
        gpl_file.close()

# Open and split the file by elements
gpl_list = (open(sys.argv[1],"r").read()).split()

# Analyse the list and download the files
for elem in gpl_list:
        if "..." in elem: # If GPL1...GPL7
                start = int(elem.split("...")[0][3:])
                end = int(elem.split("...")[1][3:]) 
                series = start
                while series <= end:
                        GPL = "GPL" + str(series)
                        download(GPL)
                        series+=1
        else:
                GPL = elem
                download(GPL)

print "Download completed"


